#ifndef DOM_HPP
#  define DOM_HPP

template <class unit, typename real_t>
class dom
{
  public: virtual ~dom() {} // enforces execution of child destructors

  private: dom *left, *rght;
  public: virtual void hook_neighbours(dom *l, dom *r) 
  { 
    if (l != NULL) left = l; 
    if (r != NULL) rght = r; 
  }

  public: virtual quantity<unit, real_t> *left_edge(int n) = 0;
  public: virtual quantity<unit, real_t> *rght_edge(int n) = 0;

  public: quantity<unit, real_t> *left_halo_data(int n) { return left->rght_edge(n); }
  public: quantity<unit, real_t> *rght_halo_data(int n) { return rght->left_edge(n); }

  public: bool choose_an(adv<unit, real_t> **a, int *n, int t, adv<unit, real_t> *advsch, adv<unit, real_t> *fllbck)
  {
    assert(advsch->time_levels() <= 3); // FIXME: support for other values
    bool fallback = (t == 0 && advsch->time_levels() == 3); 
    *a = fallback ? fllbck : advsch;
    *n = (*a)->time_levels() - 2;
    return fallback;
  }
  
  public: virtual void integ_loop(int nt, quantity<si::dimensionless, real_t> &C) = 0;
};

#endif
