#ifndef DOM_PARALLEL_SERIAL_HPP
#  define DOM_PARALLEL_SERIAL_HPP

#  include "dom_parallel.hpp"

template <class unit, typename real_t>
class dom_parallel_serial : public dom_parallel<unit, real_t>
{
  public: dom_parallel_serial(adv<unit, real_t> *fllbck, adv<unit, real_t> *advsch, int i_min, int i_max, int nk)
    : dom_parallel<unit, real_t>(fllbck, advsch, i_min, i_max, nk)
  {
    if (nk != 1) error_macro("invalid number of subdomains (" << nk << " != 1)")
  }

  public: void barrier() {}

  public: void integ_loop(int nt, quantity<si::dimensionless, real_t> &C)
  {
    this->integ_loop_k(nt, C, 0);
  }
};
#endif
